#!/usr/bin/perl

use strict;
use warnings;

use Socket;

my $host='localhost';
my $port=2010;

my $iaddr = inet_aton($host)                   || Error("no host: $host");
my $paddr = sockaddr_in($port, $iaddr);

my $proto = getprotobyname('tcp');
socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || Error("socket: $!");
connect(SOCK, $paddr)                       || Error("connect: $!");
select(SOCK); $| = 1; select(STDOUT);


my @reply2xx;
my @reply3xx;
my @reply4xx;

sub error() {
    SendCmd("Quit");

	close SOCK;

    exit 1;
}

sub ReadReply() {
	@reply2xx=undef;
	@reply3xx=undef;
	@reply4xx=undef;
	
	while (<SOCK>) {
		print "< $_";
		if ($_ =~ /^2/) { @reply2xx=split(/\s+/,$_,2); last; }
		if ($_ =~ /^3/) { @reply3xx=split(/\s+/,$_); }
		if ($_ =~ /^4/) { @reply4xx=split(/\s+/,$_,2); }
	}
	return 0 if defined $reply4xx[0];
	return 1;
}

sub SendCmd(*) {
	my ($cmd)=@_;
	
	print "> $cmd\n";
	print SOCK "$cmd\n";
	
	return ReadReply;
}
	
sub HelloWorld() {
    SendCmd 'menu=NewMenu "Hello world, what do you think?"' or return 0;
    SendCmd 'opt1=menu.AddOsdItem "This is awesome!"' or return 0;
    SendCmd "opt2=menu.AddOsdItem \"You ain't seen nothing yet\"" or return 0;
    SendCmd 'opt3=menu.AddOsdItem "All your OSD are belong to us"' or return 0;
    SendCmd 'menu.Show' or return 0;
    SendCmd 'menu.EnableEvent keyOk close' or return 0;
    SendCmd 'menu.SleepEvent' or return 0;

    return 0 if ($reply3xx[0] != 300);

	if ($reply3xx[2] eq "close") {
        SendCmd 'Message "You did not pick anything."' or return 0;
        return 1;
    }
    return 0 if ($reply3xx[2] ne "keyOk");
    
    SendCmd 'menu.GetCurrent' or return 0;
    return 0 if ($reply3xx[0] != 302);

	if ($reply3xx[2] eq "opt1") {
        SendCmd 'Message "It is!"' or return 0;
	} elsif ($reply3xx[2] eq "opt2") {
        SendCmd 'Message "B-B-B-Baybee!"' or return 0;
	} elsif ($reply3xx[2] eq "opt3") {
        SendCmd 'Message "You are on the way to display!"' or return 0;
	}
    SendCmd 'menu.SendState osEnd' || return 0;
    return 1;
}


ReadReply;
SendCmd 'Version 0' or error;

HelloWorld or error;

SendCmd "Quit";

close(SOCK);
